; ##############################################################################
; ##############################################################################
; ##############################################################################
ANZEIGE_BEGRUESSUNG:
;	call LCD_CLEAR	; ZEILE1	
	call LCD_ZEILE1	; ZEILE1	
	ldi ZH, high(TEXT_BEGRUESSUNG_1*2)	; TEXT 
	ldi ZL,  low(TEXT_BEGRUESSUNG_1*2)
	call LCD_ANZEIGE_TEXT_Z
	call LCD_ZEILE2	; ZEILE2	
	ldi ZH, high(TEXT_BEGRUESSUNG_2*2)	; TEXT 
	ldi ZL,  low(TEXT_BEGRUESSUNG_2*2)
	call LCD_ANZEIGE_TEXT_Z
	call LCD_ZEILE3	; ZEILE3	
	ldi ZH, high(TEXT_BEGRUESSUNG_3*2)	; TEXT	
	ldi ZL,  low(TEXT_BEGRUESSUNG_3*2)
	call LCD_ANZEIGE_TEXT_Z
	call LCD_ZEILE4	; ZEILE4	
	ldi temp1,BYTE1(CPU_TAKT)
	ldi temp2,BYTE2(CPU_TAKT)
	ldi temp3,BYTE3(CPU_TAKT)
	ldi temp4,BYTE4(CPU_TAKT)
	call FUNKTION_DIVISION_32_1000
	call FUNKTION_DIVISION_32_1000
	call LCD_ZAHL_TEMP1_2_3_4
	call LCD_M
	call LCD_H
	call LCD_z_
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
ANZEIGE_SYSTEM:
;	call LCD_CLEAR		; ZEILE1	
	call LCD_ZEILE1	; ZEILE1	
	call LCD_S
	call LCD_Y
	call LCD_S
	call LCD_T
	call LCD_E
	call LCD_M
; ------------------------------------------------------------------------------
	call LCD_ZEILE2	; ZEILE2	
	call LCD_T
	call LCD_DOPPEL_PUNKT
	LDS temp1,(adr_TASTE)
	call LCD_ZAHL_TEMP1	
; ------------------------------------------------------------------------------
	call LCD_ZEILE3	; ZEILE3	
	ldi temp1,LOW (RAMEND)
	ldi temp2,HIGH(RAMEND)
	ldi temp3,LOW (SRAM_START)
	ldi temp4,HIGH(SRAM_START)
	sub temp1,temp3
	sbc temp2,temp4
	call LCD_ZAHL_TEMP1_2
; ------------------------------------------------------------------------------
	call LCD_ZEILE4	; ZEILE4	
	call LCD_Z
	call LCD_DOPPEL_PUNKT
	LDS temp1,(adr_TEST_ZAEHLER_0)
	LDS temp2,(adr_TEST_ZAEHLER_1)
	LDS temp3,(adr_TEST_ZAEHLER_2)
	LDS temp4,(adr_TEST_ZAEHLER_3)
	call LCD_ZAHL_TEMP1_2_3_4
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
ANZEIGE_HAUPT_MENUE:
;	call LCD_CLEAR		; ZEILE1	
	call LCD_ZEILE1	; ZEILE1	
	call ANZEIGE_ZEIT
	; ZEILE2	
	call LCD_ZEILE2
	call ANZEIGE_DATUM
	; ZEILE3	
	call LCD_ZEILE3
	call ANZEIGE_CID_PNM
	call LCD_SPACE
	call ANZEIGE_SD_CAPACITY
	; ZEILE4	
	call LCD_ZEILE4
	call ANZEIGE_CID_MDT
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
ANZEIGE_SD_INFO:
	call LCD_ZEILE1	; ZEILE1	
	call LCD_M
	call LCD_a_
	call LCD_n_
	call LCD_u_
	call LCD_DOPPEL_PUNKT

	ldi ZL,LOW (adr_SD_CID_REGISTER_BEREICH+15)	; Initialisierung	
	ldi ZH,HIGH(adr_SD_CID_REGISTER_BEREICH+15)
	ldi temp8,120					; START	
	ldi temp9,127					; ENDE	
	call FUNKTION_SRAM_SELECT_Z_8_9	; temp8=START	temp9=ENDE
	call LCD_ANZEIGE_HEX_TEMP1
	
	call LCD_ZEILE2	; ZEILE2	


	call LCD_ZEILE3	; ZEILE3	

	
	call LCD_ZEILE4	; ZEILE4	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
ANZEIGE_CSD_REGISTER:
;	call LCD_CLEAR		; ZEILE1	
	call LCD_ZEILE1	; ZEILE1	
	call LCD_C
	call LCD_S
	call LCD_D
	call LCD_MINUS
	call ANZEIGE_TEXT_REGISTER
; ------------------------------------------------------------------------------
	call LCD_ZEILE2	; ZEILE2	
	ldi ZL,LOW (adr_SD_CSD_REGISTER_BEREICH)
	ldi ZH,HIGH(adr_SD_CSD_REGISTER_BEREICH)
	call ANZEIGE_SRAM_DETAIL
; ------------------------------------------------------------------------------
	call LCD_ZEILE3	; ZEILE3	
	call ANZEIGE_SRAM_DETAIL
; ------------------------------------------------------------------------------
	call LCD_ZEILE4	; ZEILE4	
	call ANZEIGE_SRAM_DETAIL
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
ANZEIGE_CSD_REGISTER_INFO:
;	call LCD_CLEAR		; ZEILE1	
	call LCD_ZEILE1	; ZEILE1	
	call LCD_C
	call LCD_S
	call LCD_D
	call LCD_SPACE
	call LCD_S
	call LCD_T
	call LCD_DOPPEL_PUNKT
	LDS temp1,(adr_SD_CSD_STRUCTURE)
	call LCD_ZAHL_TEMP1
	call LCD_KLAMMER_AUF
	call LCD_V
	LDS temp1,(adr_SD_CSD_STRUCTURE)
	inc temp1
	call LCD_ZAHL_TEMP1
	call LCD_KLAMMER_ZU
; ------------------------------------------------------------------------------
	call LCD_ZEILE2	; ZEILE2	
	call LCD_B
	call LCD_L
	call LCD_DOPPEL_PUNKT
	LDS temp1,(adr_SD_CSD_READ_BL_LEN)
	call LCD_ZAHL_TEMP1

	call LCD_S
	call LCD_M
	call LCD_DOPPEL_PUNKT
	LDS temp1,(adr_SD_CSD_C_SIZE_MULT)
	call LCD_ZAHL_TEMP1

	call LCD_C
	call LCD_M
	call LCD_DOPPEL_PUNKT
	LDS temp1,(adr_SD_CSD_MULT_L)
	LDS temp2,(adr_SD_CSD_MULT_H)
	call LCD_ZAHL_TEMP1_2
; ------------------------------------------------------------------------------
	call LCD_ZEILE3	; ZEILE3	
	call LCD_C
	call LCD_S
	call LCD_DOPPEL_PUNKT
	LDS temp1,(adr_SD_CSD_C_SIZE_0)
	LDS temp2,(adr_SD_CSD_C_SIZE_1)
	LDS temp3,(adr_SD_CSD_C_SIZE_2)
	LDS temp4,(adr_SD_CSD_C_SIZE_3)
	call LCD_ZAHL_TEMP1_2_3_4

	call LCD_B
	call LCD_N
	call LCD_DOPPEL_PUNKT
	LDS temp1,(adr_SD_CSD_BLOCKNR_0)
	LDS temp2,(adr_SD_CSD_BLOCKNR_1)
	LDS temp3,(adr_SD_CSD_BLOCKNR_2)
	LDS temp4,(adr_SD_CSD_BLOCKNR_3)
	call LCD_ZAHL_TEMP1_2_3_4
; ------------------------------------------------------------------------------
	call LCD_ZEILE4	; ZEILE4	
	call ANZEIGE_SD_CAPACITY
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
ANZEIGE_CID_REGISTER:
;	call LCD_CLEAR		; ZEILE1	
	call LCD_ZEILE1	; ZEILE1	
	call LCD_C
	call LCD_I
	call LCD_D
	call LCD_SPACE
	call ANZEIGE_CID_PNM
	call LCD_ZEILE2	; ZEILE2	
	ldi ZL,LOW (adr_SD_CID_REGISTER_BEREICH)
	ldi ZH,HIGH(adr_SD_CID_REGISTER_BEREICH)
	call ANZEIGE_SRAM_DETAIL
	call LCD_ZEILE3	; ZEILE3	
	call ANZEIGE_SRAM_DETAIL
	call LCD_ZEILE4	; ZEILE4	
	call ANZEIGE_SRAM_DETAIL
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Product name [103:64]															
ANZEIGE_CID_PNM:
	LDS temp,(adr_SD_CID_REGISTER_BEREICH+3)
	call LCD_DATA_TEMP
	LDS temp,(adr_SD_CID_REGISTER_BEREICH+4)
	call LCD_DATA_TEMP
	LDS temp,(adr_SD_CID_REGISTER_BEREICH+5)
	call LCD_DATA_TEMP
	LDS temp,(adr_SD_CID_REGISTER_BEREICH+6)
	call LCD_DATA_TEMP
	LDS temp,(adr_SD_CID_REGISTER_BEREICH+7)
	call LCD_DATA_TEMP
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
ANZEIGE_CID_MDT:
	call LCD_D
	call LCD_a_
	call LCD_t_
	call LCD_DOPPEL_PUNKT
	ldi ZL,LOW (adr_SD_CID_REGISTER_BEREICH+15)	; Initialisierung	
	ldi ZH,HIGH(adr_SD_CID_REGISTER_BEREICH+15)
	ldi temp8,8						; START	
	ldi temp9,11					; ENDE	
	call FUNKTION_SRAM_SELECT_Z_8_9	; temp8=START	temp9=ENDE
	call LCD_ZAHL_2STELLEN_TEMP1
	call LCD_SCHRAEGSTRICH
	ldi ZL,LOW (adr_SD_CID_REGISTER_BEREICH+15)	; Initialisierung	
	ldi ZH,HIGH(adr_SD_CID_REGISTER_BEREICH+15)
	ldi temp8,12					; START	
	ldi temp9,19					; ENDE	
	call FUNKTION_SRAM_SELECT_Z_8_9	; temp8=START	temp9=ENDE
	call LCD_ZAHL_2STELLEN_TEMP1
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
ANZEIGE_SRAM_DETAIL:
	ldi temp9,8
ANZEIGE_SRAM_DETAIL_s:
	LD temp1,Z+
	call LCD_ANZEIGE_HEX_TEMP1
	dec temp9
	brne ANZEIGE_SRAM_DETAIL_s
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
ANZEIGE_RX:
	ldi temp1,BYTE1(100)
	ldi temp2,BYTE2(100)
	ldi temp3,BYTE3(100)
	ldi temp4,BYTE4(100)
	STS(adr_SD_PHYS_SEKTOR_BYTE0),temp1 
	STS(adr_SD_PHYS_SEKTOR_BYTE1),temp2 
	STS(adr_SD_PHYS_SEKTOR_BYTE2),temp3 
	STS(adr_SD_PHYS_SEKTOR_BYTE3),temp4 
	call SD_CMD17_RX512

	call LCD_ZEILE1	; ZEILE1	
	call LCD_D
	call LCD_A
	call LCD_T
	call LCD_A
	call LCD_MINUS
	call LCD_R
	call LCD_X
	call LCD_ZEILE2	; ZEILE2	
	ldi ZL,LOW (adr_SD_DATEN)
	ldi ZH,HIGH(adr_SD_DATEN)
	call ANZEIGE_SRAM_DETAIL
	call LCD_ZEILE3	; ZEILE3	
	call ANZEIGE_SRAM_DETAIL
	call LCD_ZEILE4	; ZEILE4	
	call ANZEIGE_SRAM_DETAIL

ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
ANZEIGE_TX:
	call LCD_ZEILE1	; ZEILE1	
	call LCD_D
	call LCD_A
	call LCD_T
	call LCD_A
	call LCD_MINUS
	call LCD_T
	call LCD_X
	call LCD_ZEILE2	; ZEILE2	


	; Z-ZEIGER initialisieren	
	ldi ZL, LOW(adr_SD_DATEN)
	ldi ZH,HIGH(adr_SD_DATEN)
	LDS temp,(adr_ss)
	ST Z+,temp
	ST Z+,temp
	ST Z+,temp
	ST Z+,temp
	ST Z+,temp
	ST Z+,temp
	ST Z+,temp
	ST Z+,temp
	
	ldi temp1,BYTE1(100)
	ldi temp2,BYTE2(100)
	ldi temp3,BYTE3(100)
	ldi temp4,BYTE4(100)
	STS(adr_SD_PHYS_SEKTOR_BYTE0),temp1 
	STS(adr_SD_PHYS_SEKTOR_BYTE1),temp2 
	STS(adr_SD_PHYS_SEKTOR_BYTE2),temp3 
	STS(adr_SD_PHYS_SEKTOR_BYTE3),temp4 
	call SD_CMD24_TX512

	call WAIT_100ms
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
ANZEIGE_ZEIT:
	LDS temp1,(adr_hh)
	call LCD_ZAHL_2STELLEN_TEMP1	
	call LCD_DOPPEL_PUNKT
	LDS temp1,(adr_mm)
	call LCD_ZAHL_2STELLEN_TEMP1	
	call LCD_DOPPEL_PUNKT
	LDS temp1,(adr_ss)
	call LCD_ZAHL_2STELLEN_TEMP1	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
ANZEIGE_DATUM:
	LDS temp1,(adr_TAG)
	call LCD_ZAHL_2STELLEN_TEMP1
	call LCD_PUNKT
	LDS temp1,(adr_MONAT)
	call LCD_ZAHL_2STELLEN_TEMP1
	call LCD_PUNKT
	LDS temp1,(adr_JAHR)
	call LCD_ZAHL_2STELLEN_TEMP1
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
ANZEIGE_SD_CAPACITY:
	LDS temp1,(adr_SD_CSD_CAPACITY_0)
	LDS temp2,(adr_SD_CSD_CAPACITY_1)
	LDS temp3,(adr_SD_CSD_CAPACITY_2)
	LDS temp4,(adr_SD_CSD_CAPACITY_3)
	call LCD_ZAHL_TEMP1_2_3_4
	call LCD_M
	call LCD_B
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
LCD_TEXT_CMD:
	call LCD_C
	call LCD_M
	call LCD_D
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
LCD_TEXT_ACMD:
	call LCD_A
	call LCD_C
	call LCD_M
	call LCD_D
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
LCD_TEXT_OK:
	call LCD_SPACE
	call LCD_O
	call LCD_K
	rjmp LCD_SPACE
; ##############################################################################
; ##############################################################################
; ##############################################################################
LCD_TEXT_ERROR:
	call LCD_E
	call LCD_R
	call LCD_R
	call LCD_O
	call LCD_R
	rjmp LCD_SPACE
	call wait_1s
	rjmp LCD_SPACE
; ##############################################################################
; ##############################################################################
; ##############################################################################
ANZEIGE_TEXT_RESET:
	call LCD_R
	call LCD_E
	call LCD_S
	call LCD_E
	call LCD_T
	rjmp LCD_SPACE
; ##############################################################################
; ##############################################################################
; ##############################################################################
ANZEIGE_TEXT_REGISTER:
	call LCD_R
	call LCD_E
	call LCD_G
	call LCD_I
	call LCD_S
	call LCD_T
	call LCD_E
	call LCD_R
	rjmp LCD_SPACE
; ##############################################################################
; ##############################################################################
; ##############################################################################
LCD_TESTWERT_TEMP1:
	call LCD_CLEAR	; ZEILE1	
	push temp1
	call LCD_ANZEIGE_HEX_TEMP1	
	call LCD_SPACE
	pop temp1
	call LCD_ZAHL_TEMP1
LCD_TESTWERT_s:
	WDR
	rjmp LCD_TESTWERT_s
; ##############################################################################
; ##############################################################################
; ##############################################################################

