; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE:
	LDS temp,(adr_TASTE)
	tst temp
	breq MENUE_ACTION
	rcall LCD_CLEAR
MENUE_ACTION:
	LDS temp,(adr_TASTE)
	cpi temp,(TASTE_MENUE_PLUS)	; TASTE  gedrckt ?	
	breq MENUE_PLUS
	cpi temp,(TASTE_MENUE_MINUS); TASTE  gedrckt ?	
	breq MENUE_MINUS
	cpi temp,(TASTE_MENUE_MINUS+TASTE_MENUE_PLUS); TASTE  gedrckt ?	
	breq MENUE_RESET
	rjmp MENUE_RUN
;-----------------------------
MENUE_RESET:
	rcall LCD_CLEAR		
	rcall ANZEIGE_TEXT_RESET
	rcall LCD_PUNKT3
	CLI 										;Global Interrupt Disable
	cbi (LED_GRUEN_PORT),(LED_GRUEN_PIN_NR)		; GRN an	
	cbi (LED_GELB_PORT) ,(LED_GELB_PIN_NR)		; GELB an	
	cbi (LED_ROT_PORT)  ,(LED_ROT_PIN_NR)		; ROT  an	
MENUE_RESET_s:
	rjmp MENUE_RESET_s
;-----------------------------
MENUE_PLUS:
	LDS temp,(adr_MENUE)
	inc temp
	STS (adr_MENUE),temp
	rjmp MENUE_RUN
;-----------------------------
MENUE_MINUS:
	LDS temp,(adr_MENUE)
	tst temp
	breq MENUE_RUN
	dec temp
	STS (adr_MENUE),temp
	rjmp MENUE_RUN
;-----------------------------
MENUE_RUN:
	ldi ZL, LOW(MENUE_SPRUNGMARKE)	; Z-ZEIGER initialisieren	
	ldi ZH,HIGH(MENUE_SPRUNGMARKE)
	LDS temp,(adr_MENUE)
	add ZL,temp
	adc ZH,NULL
	IJMP	; SPRUNG nach Z
;-----------------------------
MENUE_SPRUNGMARKE:
	rjmp ANZEIGE_HAUPT_MENUE
	rjmp ANZEIGE_SD_INFO
	rjmp ANZEIGE_CSD_REGISTER_INFO
	rjmp ANZEIGE_CID_REGISTER
	rjmp ANZEIGE_CSD_REGISTER
	rjmp ANZEIGE_SYSTEM
	rjmp ANZEIGE_RX
	rjmp ANZEIGE_TX
	rjmp ANZEIGE_BEGRUESSUNG
	rjmp ANZEIGE_BEGRUESSUNG
	rjmp ANZEIGE_BEGRUESSUNG
	; Fehlerprfung
	STS (adr_MENUE),NULL
	rjmp MENUE
; ##############################################################################
; ##############################################################################
; ##############################################################################
